# **weiz`PVP`** : *__CHANGELOG__*

#### 📌 If you come across an issues or a bug _(even in alpha or beta versions)_, please be sure to report them with any details you have.

## **Version** : `v1.55-beta3`

### 🛠️ **CODE & BACKEND**
* A few fixes.

----

## **Version** : `v1.55-beta2`

### 🛠️ **CODE & BACKEND**
* Optimizations in a number of spots; Small CPU and memory reductions.
* Player info gathering optimized greatly; Large CPU reduction.
	* *Still a good bit more that could be done.*
*
* DB Updates to get ready for kos and player browser.
* Combat Log and Health events/data collection changes:
	* Updated some methods of obtaining data.
	* Less cpu/mem usage.

### 📐 **INTERFACE & DESIGN**
* Options Updated
	* A few updates in places.
		* Better grouping of options.
		* Text formatting.
	* Enable in Arena option added.
	* Added stealth detection options for display and sound under Alerts section.
	* BETA section added for BETA Options.
		* LagMode options added to BETA section.
			* Enable toggle.
			* FPS input for when to turn on LagMode.
			* Toggles at most once every 4 seconds to prevent flickering/bursting off and on.
		* More features to be added later for testing before making them official.

----

## **Version** : `v1.55-beta1`

### 🛠️ **CODE & BACKEND**
* Optimizations in a number of spots; Small CPU and memory reductions.
* Player info gathering optimized greatly; Large CPU reduction.
	* *Still a good bit more that could be done.*
* Player list sorting changes:
	* Deals with sorting larger lists better and keeping most alive and active at top.
	* Sorting of dead players fix to prevent possible flickering of location.
	* Fix for clicking a player bar in combat when the target macro isn't/couldn't be set yet due to combat lockdown.
	* Additional memory optimizations.
* DB Updates to get ready for kos and player browser.
* Combat Log and Health events/data collection changes:
	* No longer using a library to obtain data.
	* Great improvements in cpu/memory usage by using custom code instead; lowest ever usage for this addon.
	* Much more cpu-usage steady in large scale situations.
* Crosshairs improved to work better with targets without nameplates that later appears.
	* *(Target's without nameplates can happen when the WoW client is showing the max number of nameplates, which is a built-in limit.)*

### 📐 **INTERFACE & DESIGN**
* Crosshair fade out duration fixed for when the target nameplate went away or can not be found while switching targets.
* Expanded the clickable area on a bar to cover the 1 pixel gap below it as well so there are no non-clickable bar areas on the list.
* Health UI updates throttled due to them happening very often off API Events; Reduced cpu usage.
	* Health is still updated and stored, but the visual updates to the bars are throttled.
	* Death is shown and list sorted immediately and is not throttled like health updates.
	* Health updates are based on a per-player basis  by time since last update which helps space out processing vs updates everything at once.
	* Update time will be added later to config; for now it is 10 updates per second; *Many times less than before, but still quite a bit*.

----

## **Version** : `v1.54`

### 🛠️ **CODE & BACKEND**
* Optimizations in the data gathering functions for detected players.
	* Mostly memory usage reductions.

----

## **Version** : `v1.53`

### 🛠️ **CODE & BACKEND**
* Fixed another potential area where the player bars could flicker/swap with other players.
	* This fix made it easier to reduce even more processing by properly targeting single bars for updates.
	* This, along with other fixes have led to the lowest CPU and mem usage yet for weizPVP.
* Continued to optimize events and the processing of unit data to run even better in heavy pvp.

----

## **Version** : `v1.52`

### 🛠️ **CODE & BACKEND**
* Fixed a few small bugs making player bars jump around a bit.
* More optimization here and there.

----

## **Version** : `v1.51`

### 🛠️ **CODE & BACKEND**
* Some more optimizations;
	* List and player bar updates reduced further to be ran only when needed for visual updates.
	* Reduced running *some* functions to gather player data when we already have it; we just update the timestamp/lastseen info.
		* This will be an ongoing process. The addon is only getting faster at this point, even with new features added.

* Fixed a bug that was creating warnings while entering new zones.

### 📐 **INTERFACE & DESIGN**
* Small adjustments to transition animation of the crosshairs.

----

## **Version** : `v1.5`

### 🛠️ **CODE & BACKEND**
* Fixed some more bugs relted to crosshairs not always showing up properly in a variety of situations.
* Big Database changes;
    * All previous options (like.. 5?) will be reset to the current default. (Last time this should happen)
	* Some optimizations made in the way it functions.
	* Better and more efficient structure.
* Multiple optimizations related to updating the player lists and bars; both data and the statusbars.
	* CPU and Memory usage *looks* to be down about 30-50% overall. More optimizations to come!

### 📐 **INTERFACE & DESIGN**
* Crosshairs will now do a better job of staying on a nameplate after reaching it.
	* This also turned out to be a pretty nice optimization as well.

### 🎛️ **FUNCTIONALITY**
* Slash commands have been simplified more since more and more are going to WoW's option menu.
* Fixed some weird issues with the crosshair acting oddly via options or in BGs.
* Fixed problems with when toggle BGs on or off while in them.

### 📘 **MISC NOTES - Next versions and 2.0**
* The goal before 2.0 is to stabilize and optimize for the most part. That will give us a solid base going into 2.0 where we have some big things planned.
* 2.0 Goals at the moment are:
    * Have Kill On Sight options, alerts, targeting, etc.
    * Keep track of kill /death ratios.
    * Display for browsing the Player Database.
    * A custom made options window.
    * Menu button on the top bar for quick access to some basic options.

----

## **Version** : `v1.22`

### 🛠️ **CODE & BACKEND**
* Fixed a number of bugs while looking into sorting issues.
    * Sorting issues out of combat seem resolved.

----

## **Version** : `v1.2-release`

### 📐 **INTERFACE & DESIGN**
* Adjusted Crosshair some animations and textures.


### 🛠️ **CODE & BACKEND**
* Cleaned up assets and old comments for release.
* Optimized some code dealing with list management.

----

## **Version** : `v1.2-beta1`

### 📐 **INTERFACE & DESIGN**
* Reworked Crosshairs look and functionality.
    * Pixel-perfect redesign of image assets and placement.
    * Changed some texture being used to bring everything together a little tighter.
    * Adjusted some animations.
    * Added option to show target name and guild.

### 🎛️ **FUNCTIONALITY**
* Reworked Crosshairs functionality.
    * Added changing of colors and opacity based on distance from target.

### 🛠️ **CODE & BACKEND**
* Added some code to throttled the gathering of some player information as to not use too much CPU in larger (40vs40+) fights.
* Cleaned up code and media assets for beta; more planned when it's ready to go live.
* Fixed a few small/less frequent issues with Crosshairs not finding a player's nameplate to lock on to.

----

## **Version** : `v1.2-alpha6`

### 📐 **INTERFACE & DESIGN**
* Updated, created, and pixel-adjusted many art assets.
* Changed the style of the crosshair. Plans to have options to change the look in future.
* Colors and elements on crosshairs change depending on if they're within ~40 yards.
* Fine tuned and created new functions to adjust class colors for different elements in a more controlled manner.
* Started creating more layers for the crosshair to display more data:
    * Name
    * Guild Name
    * Indicators for when your target is targeting you.
    * More planned (eventual nameplate replacement for targets)
* New options section for added changes to crosshair so they can be enabled/disabled.
    * _(Most new things are disabled by default.)_

### 🎛️ **FUNCTIONALITY**
* Added a new command: '`/wpvp ver`' to display the current version of weizPVP that is installed and running.
    * _(You can also check the version via the Interface Options)_
* Fixed some layering issues with crosshairs.
* Fixed issue when a crosshair was looking for a nameplate that wasn't created yet, even if a player is targeted.


### 🛠️ **CODE & BACKEND**
* Continuing work on optimizing code as I come across it while fixing bugs and adding new features.
    * New methods are being used to now to help reduce the number of variables used and logic needed; reducing memory and CPU usage _**(which is doing quite well as it is)**_

* After cleaning out unused assets that were initially planned to be used much sooner, the package size of the addon is down to about **530KB**, far less than version 1.13's **1.9MB**.
    * Most of the previous assets were not doing much other than registering with LibSharedMedia to be used with other addons if desired, but otherwise weren't doing much after being initially loaded.
    * Some reduction of size has been due to reduced code and better designed data tables as well, though the bulk was easily from media assets.


----

## **Version** : `v1.2-alpha5`

### 🎛️ **FUNCTIONALITY**
* Fixed a number of small, infrequent bugs relating to the crosshair code.
* The targeted nameplate should now always show on top of the crosshair UI, as to avoid covering names/health bars, etc.
    * These updates are done every so often to ensure proper layering of the nameplate, crosshair, and other UI elements.

### 📐 **INTERFACE & DESIGN**
* Some more UI tweaks on the crosshair to keep them visible and dynamic, but no too overwhelming.

----

## **Version** : `v1.2-alpha4`

### 🎛️ **FUNCTIONALITY**
* Changes to the crosshairs again; both design and code. Both are better. Further additions to the crosshairs will be very simple and quick.
* 🎁 As per request, an options is now available that allows you to play an alert when a new enemy is added to the list.
    * This is disabled by default.
    * Picked a sound that someone  would notice, but it isn't obnoxious.
    * You can change this settings under Interface Options or via the command: _**`/wpvp config`**_

----

## **Version** : `v1.2-alpha3`

### 🎛️ **FUNCTIONALITY**
* Updated the crosshair code and assets for a more optimized experience and a better look.
* Fixes an issue where the crosshairs were not 100% locked to the nameplate after the crosshair was moved to the nameplate location
    * _The crosshairs tended to lag behind slightly, especially while tuning the camera quickly. This is now fixed._
* Optimized how settings are being loaded. Still work to do in creating a universal system for updating settings when they get added or forces to a certain parameter.
* Added in an option for an audio alert when a new player is detected that was not already on the list.
    * *The playing of the sound is throttled so that it wont play multiple times over itself, preventing being ear spammed. The softer sound was used to help let you know, but without being annoying is heard semi-often.*

----
## **Version** : `1.2-alpha2`

### 🎛️ **FUNCTIONALITY**
* Added options to allow being enabled in Battlegrounds.
    * Addon settings can be accessed via WoW's Interface Options.
----

## **Version** : `1.2-alpha1`

### 📐 **INTERFACE & DESIGN**
* Player bars now will show the role of the player. Unknown icon show if not determined yet.
* Created a set of custom role icons.
* A number of small changes to the refresh and min/max window buttons. No more overlapping of clickable areas.
* Changed the look of the targeted player to make it a little cleaner and use less code and assets.
* The crosshairs should now move at the same speed, no matter what your FPS is. Moving speed has been slightly increased.
* Small fix to crosshairs were the lines were briefly not going to the edge of the screen when initially changing targets.
* Stabilized the player list to prevent rearranging of order when a lot of players are detected at once.
* **Increased** player timeouts to 31 _`(up from 22)`_ seconds to allow 30 second refreshing buffs from traits and other spells to kick in before we remove them from the list.
    * *Active' player timeout is still set to 14 seconds to keep players on top who are more active (casts/swings/targets/etc.)*
* Mouseover highlighting of player bars modified; now highlights under the text and icons on the bar.
* Stealth Alert popup has been fixed so that background fits inside of the borders.

### 🎛️ **FUNCTIONALITY**
* Improved detection of players.
* Health updates now happen more often.
* Players will not longer to marked as inactive while their nameplates are still visible.
* Player Roles are now detected based on spells and abilities seen in the combat log.
* Fixed *some* issues with the player bars not showing a stealth player as being stealth.
* No longer a delay in saving the window position and dimensions when you resize or move.

### 📘 **MISC NOTES**
* Cleaned up unused media assets, code, and files.

---

## **Version** : `1.13`

### 📐 **INTERFACE & DESIGN**
* Minor changes to bar textures.

### 🎛️ **FUNCTIONALITY**
* Addressed Issue #13 on Curseforge: Pinning options are now synced across methods (slash, right click, interface options).
* Slash commands for lock and pin now toggle on/off.
    * The 'unpin' and 'unlock' slash commands removed as there is one command to toggle them.

---

## **Version** : `1.12`

### 📐 **INTERFACE & DESIGN**
* Added an indicator to the player bars to show your target.
* Added small animation effects to min/max button.
* Resizing the main window will now snap at heights that show only complete bars. No more cutoff bars; Perfection.
* Clamping of the window to the screen has been improved. No part of the window should be able to be moved off-screen anymore.
* Scrolling now correctly scrolls in even increments based on the size and spacing of the player bars.
* Right-Clicking on the title bar at the top of the addon addon will now toggle the 'pin' option, and will output in chat to let you know as well.
* Window location and size is now saved between sessions.

### 🎛️ **FUNCTIONALITY**
* The addon is now disabled in all instances (even BGs and Arenas). This may change later, but in order to have it work properly a decent big of work is required as they use additional API calls specific to the instance.


